/*
  rev 31/12/2016   Drapeau en RAM 0x3E
// variables globales
unsigned char sec, min1, hr, week_day, day, mn, year,ctrl;
char  tnum[4];
int dummy;
unsigned char Date[12];
unsigned char Time[9];
int DS1307_Started ;
*/

/*
#define With_I2C2

#ifdef With_I2C1
#define  IC2x_Start I2C1_Start
#define  I2Cx_Wr I2C1_Wr
#define  I2Cx_Read I2C1_Read
#define  I2Cx_Repeated_Start I2C1_Repeated_Start
#define  I2Cx_Stop I2C1_Stop
#endif

#ifdef With_I2C2
#define  I2Cx_Start I2C2_Start
#define  I2Cx_Wr I2C2_Wr
#define  I2Cx_Rd I2C2_Rd
#define  I2Cx_Repeated_Start I2C2_Repeated_Start
#define  I2Cx_Stop I2C2_Stop
#endif


extern int dummy;
extern unsigned char Date[];
extern unsigned char Time[];
extern unsigned char DS1307_Started ;


void Write_DS1307(unsigned char addresse, unsigned char dd)   ;
unsigned char Read_DS1307(unsigned char address) ;
void Start_DS1307(void);
void Stop_DS1307(void);
void Init_DS1307(void);
void Write_Time(void);
void Read_Time(char *sec, char *min, char *hr, char *week_day, char *day, char *mn, char *year) ;
void Transform_Time(char  *sec, char *min, char *hr, char *week_day, char *day, char *mn, char *year);
void Prepare_Display_Time(char sec, char min, char hr, char week_day, char day, char mn, char year);
*/

#include "RTC_DS1307_I2Cx.h"

void Write_DS1307(unsigned char addresse, unsigned char dd)
{
int i;
   I2C_Start();
   I2Cx_Wr(DS1307);
   I2Cx_Wr(addresse);
   I2Cx_Wr(dd);
   I2Cx_Repeated_Start();
  //   I2Cx_Stop();
  // I2Cx_Start();
   // Get an ACK from the slave but give up after 3 goes don't hang waiting.
   for(i=0;i<3;i++) 
   {
      if (I2Cx_Wr(DS1307)==1)
       {  // Check for NACK
         I2Cx_Start();
      } else
       break;            // found ACK
   }
   I2Cx_Stop();
 }

 unsigned char Read_DS1307(unsigned char address)
{
   I2Cx_Start();
   I2Cx_Wr(DS1307);
   I2Cx_Wr(address);
   I2Cx_Start();
   I2Cx_Wr(DS1307+1);           // b0 is read
   dummy=I2Cx_Rd(0);         // Read with NACK.
   I2Cx_Stop();
   return(dummy);
}


void Start_DS1307()
{

  if (DS1307_Started) return ;
   dummy = Read_DS1307(0) & ~0x80; // CH = 0 - start.
   Write_DS1307(0,dummy);
   DS1307_Started = 1;
}

void Stop_DS1307()
{
   dummy = Read_DS1307(0) | 0x80; // CH = 1 - stop.
   Write_DS1307(0,dummy);
   DS1307_Started = 0;
}

void Init_DS1307()
{
   if (Read_DS1307(0x3E)==0x20) return;  // adresse fin de RAM-1
   Start_DS1307(); // demarre oscillator
   // mode 24H
   Write_DS1307(2,Read_DS1307(2) & ~(1<<6) ); // RAZ le bit 6  pour passer en mode 24 heures.
   Write_DS1307(0,0x00 & 0x7F); // secondes
   Write_DS1307(1,0x59);  //   minutes   0-59
   Write_DS1307(2,0x23 & ~(1<<6) ); // mode 24 hour + heures
   Write_DS1307(3,0x07);  // jour de la semaine  1-7
   Write_DS1307(4,0x28);  // date  1  31
   Write_DS1307(5,0x12);  // mois 1-12
   Write_DS1307(6,0x16);  // Annee  0-99
   Write_DS1307(0x3E,0x20);  // drapeau RTC initalise

}

void Write_Date_Time(char *sec, char *min, char *hr, char *week_day, char *day, char *month, char *year)
{
        I2Cx_Start();        // start signal
        I2Cx_Wr(DS1307);     // addresse DS1307
        I2Cx_Wr(0);          // start from REG 0
        I2Cx_Wr(0x80+ sec);  // write $80 to REG 0. (pause counter + 0 sec)
        I2Cx_Wr(min);        // write Minutes to REG 1
        I2Cx_Wr(hr);         // write Heures (mode 24H) to REG 2
        I2Cx_Wr(week_day);   // write jour to REG 3
        I2Cx_Wr(day);        // write 27 date to REG 4
        I2Cx_Wr(month);         // write 12 Dec to REG 5
        I2Cx_Wr(year);       // write 16 year to REG 6
//        I2Cx_Repeated_Start();
        I2Cx_Stop();         // issue stop signal
        I2Cx_Start();        // issue start signal
        Delay_ms(10);
        I2Cx_Wr(DS1307);     // address DS1307
        I2Cx_Wr(0);          // start from word at address 0
        I2Cx_Wr(0);          // write 0 to REG0 (enable counting + 0 sec)
        I2Cx_Stop();         // issue stop signal
}

void Read_Date_Time(char *sec, char *min, char *hr, char *week_day, char *day, char *month, char *year)
{
        I2Cx_Start();
        I2Cx_Wr(DS1307);
        I2Cx_Wr(0);
        I2Cx_Repeated_Start();
        I2Cx_Wr(DS1307+1);
        *sec =I2Cx_Rd(1);
        *min =I2Cx_Rd(1);
        *hr =I2Cx_Rd(1);
        *week_day =I2Cx_Rd(1);
        *day =I2Cx_Rd(1);
        *month=I2Cx_Rd(1);
        *year =I2Cx_Rd(0);
        I2Cx_Stop();
}

void Transform_Time(char  *sec, char *min, char *hr, char *week_day, char *day, char *month, char *year) 
{
        *sec  =  ((*sec & 0x70) >> 4)*10 + (*sec & 0x0F);
        *min  =  ((*min & 0xF0) >> 4)*10 + (*min & 0x0F);
        *hr   =  ((*hr & 0x30) >> 4)*10 + (*hr & 0x0F);
        *week_day =(*week_day & 0x07);
        *day  =  ((*day & 0xF0) >> 4)*10 + (*day & 0x0F);
        *month  =  ((*month& 0x10) >> 4)*10 + (*month& 0x0F);
        *year =  ((*year & 0xF0)>>4)*10+(*year & 0x0F);
}

void Prepare_Display_Time(char sec, char min, char hr, char week_day, char day, char monthn, char year)
{
       Date[0]=(day / 10) + 48;
       Date[1]= (day % 10) + 48;
       Date[2]='/';
       Date[3]=(month/ 10) + 48;
       Date[4]=(month% 10) + 48;
       Date[5]='/';
       Date[6]='2';
       Date[7]='0';
       Date[8]=(year / 10)  + 48;
       Date[9]=(year % 10)  + 48;
       Date[10]=0;
       
       Time[0]=(hr / 10)  + 48;
       Time[1]=(hr % 10)  + 48;
       Time[2]=':';
       Time[3]=(min / 10) + 48;
       Time[4]=(min % 10) + 48;
       Time[5]=':';
       Time[6]=(sec / 10) + 48;
       Time[7]=(sec % 10) + 48;
       Time[8]=0;
}